IpProject/UI_MVC/Models/QuestionViewModel.cs
using IP.BL.Domain.Flows.FlowComponents.Questions;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace UI_MVC.Models;

public class QuestionViewModel
{
    public Guid Id { get; set; } // Voeg Id toe
    public QuestionType Type { get; set; }
    public string Prompt { get; set; }
    public List<OptionViewModel> Option { get; set; }
    public bool IsOpen { get; set; } 
    public Guid SubthemaId { get; set; }
    public List<SelectListItem> Subthema { get; set; }
    
}

IpProject/UI_MVC/Controllers/LineFlowController.cs
using IP.BL.API;
using IP.BL.Managers;
using Microsoft.AspNetCore.Mvc;
using UI_MVC.Models;

namespace IpProject.UI.MVC.Controllers;

public class LineFlowController : Controller
{
    private readonly IFlowManager _flowManager;
    private readonly ISubthemeManager _subthemeManager;

    public LineFlowController(IFlowManager flowManager, ISubthemeManager subthemeManager)
    {
        _flowManager = flowManager;
        _subthemeManager = subthemeManager;
    }

    [HttpGet]
    public IActionResult Index()
    {
        var model = _flowManager.GetAllSubthemes();
        return View(model);
    }
    
    [HttpGet]
    public IActionResult Questions(Guid subthemeId)
    {
        var subtheme = _subthemeManager.GetSubtheme(subthemeId);
        var model = new SubthemeFlowViewModel
        {
            FlowItems = subtheme.FlowItems,
            Description = subtheme.Description,
            Id = subtheme.Id,
            Name = subtheme.Name,
            ModeString = ModeManager.GetCurrentMode()
        };
        return View(model);
    }
    
    [HttpGet]
    public IActionResult ThankPage()
    {
        return View();
    }
    
    
}

IpProject/UI_MVC/Controllers/QuestionController.cs
using IP.BL.API;
using IP.BL.Domain.Flows.FlowComponents.Questions;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using UI_MVC.Models;

namespace IpProject.UI.MVC.Controllers;

[Authorize(Roles = "admin")]
public class QuestionController : Controller
{
    private readonly IFlowManager _flowManager;

    public QuestionController(IFlowManager flowManager)
    {
        _flowManager = flowManager;
    }

    // GET
    public IActionResult Index()
    {
        var allQuestions = _flowManager.GetAllQuestionsWithOptions();
        return View(allQuestions);
    }

    [HttpGet]
    public IActionResult Add(Guid subthemaId)
    {
        var subthemas = _flowManager.GetAllSubthemes();
        var viewModel = new QuestionViewModel
        {
            SubthemaId = subthemaId,
            Subthema = subthemas
                .Select(p => new SelectListItem
                {
                    Value = p.Id.ToString(),
                    Text = p.Name
                }).ToList()
        };
        return View(viewModel);
    }

    [HttpPost]
    public IActionResult Add(QuestionViewModel questions)
    {
        if (!ModelState.IsValid)
        {
            return View();
        }

        var r = new Question()
        {
            Id = questions.Id,
            Type = questions.Type,
            Prompt = questions.Prompt,
            Options = questions.Option?.Select((o, ind) => new Option()
            {
                Label = o.Label,
                Value = ind
            }).ToList(),
            IsOpen = questions.Type == QuestionType.Open,
            SubthemeId = questions.SubthemaId
        };

        _flowManager.AddQuestion(r);
        return RedirectToAction("Index", "Question");
    }
    
    [HttpPost]
    [Route("/Question/Delete/{id}")]
    public IActionResult Delete(Guid id)
    {
        var question = _flowManager.GetQuestionById(id);
        if (question == null)
        {
            return NotFound();
        }

        _flowManager.RemoveQuestion(question);
        return RedirectToAction(nameof(Index));
    }
}

IpProject/UI_MVC/Controllers/api/QuestionsController.cs
using IP.BL.API;
using IP.BL.Domain.Flows.FlowComponents;
using IP.BL.Domain.Flows.FlowComponents.Questions;
using IpProject.UI.MVC.Models.Dtos;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace IpProject.UI.MVC.Controllers;

[Route("api/[controller]")]
[ApiController]
[Authorize(Roles = "admin")]
public class QuestionsController : ControllerBase
{
    private readonly IFlowManager _manager;

    public QuestionsController(IFlowManager manager)
    {
        _manager = manager;
    }

    [HttpGet]
    public ActionResult<IEnumerable<Subtheme>> GetSubthemes()
    {
        var subthemes = _manager.GetAllSubthemes();
        if (!subthemes.Any())
        {
            return NoContent();
        }
        return Ok(subthemes);
    }
    
    [HttpPost]
    public IActionResult Add(NewQuestionDto questionDto)
    {
        var question = new Question()
        {
            Id = questionDto.Id,
            Type = questionDto.Type,
            Prompt = questionDto.Prompt,
            Options = questionDto.Options.Select((o) => new Option()
            {
                Label = o.Label,
                Value = o.Value
            }).ToList(),
            IsOpen = questionDto.IsOpen,
            SubthemeId = questionDto.SubthemeId
        };
        
        _manager.AddQuestion(question);
        return Ok(new { message = "Questions successfully added." });
    }
    
}

IpProject/UI_MVC/Views/LineFlow/Index.cshtml
@model IEnumerable<IP.BL.Domain.Flows.FlowComponents.Subtheme>

@{
    ViewBag.Title = "LinFlowStart";
    Layout = "_Layout";
}

<div class="container">
    <div class="row">
        <div class="col-lg-4 col-md-4 col-sm-12 pt-5">
            <h1 class="text-center">Enquête</h1>
                <p>Kies het subthema dat van toepassing is voor jou.</p>
            <br/>
            <form asp-controller="LineFlow" asp-action="Questions" method="get">
                <div class="container">
                    <div class="row">
                        <label for="subtheme">Kies een subthema:</label>
                    </div>
                    @* <div class="row"> *@
                    @*     <div class="col-9"> *@
                    <div class="row input-group mb-3">
                        <select name="subthemeId" id="subtheme-dd" class="form-control" required>
                            <option value="">-- Selecteer een subthema --</option>
                            @foreach (var subtheme in Model)
                            {
                                <option value="@subtheme.Id" data="@(subtheme.Info?.Text)">@subtheme.Name</option>
                            }
                        </select>
                        @* </div> *@
                        @* <div class="col-3"> *@
                        @* <button type="button" class="startbutton input-group-text" onclick="showInfo()">Info</button> *@
                        <button type="button" class="startbutton input-group-text" onclick="showInfo()" data-bs-toggle="modal" data-bs-target="#infoModal">Info</button>
                    </div>
                </div>
                <div class="modal fade" id="infoModal" tabindex="-1" aria-labelledby="infoModalLabel" aria-hidden="true">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="infoModalLabel">Info</h5>
                                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                            </div>
                            <div class="modal-body">
                                
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm">
                        <button class="startbutton" type="submit" id="startbutton">Start enquête</button>
                    </div>
                </div>
                @* <div class="col-sm"> *@
                @*     <div class="col-sm"> *@
                @*         <div id="info-box"></div> *@
                @*     </div> *@
                @* </div> *@
            </form>
        </div>
        <div class="col-lg-8 col-md-8 col-sm-12">
            <img class="img-fluid w-100 centered-image" src="~/img/enquete.jpg" alt="enqueteimg" id="enquetestartimg"/>
        </div>
    </div>
</div>

<script src="@Url.Content("~/js/info.js")"></script>

IpProject/UI_MVC/Views/LineFlow/Questions.cshtml
@model dynamic

@{
    ViewBag.Title = "LineFlowQuestions";
    Layout = "_Layout";
}
<h2 hidden>Flow (ID: <span id="subthemeId">@Model.Id</span>)</h2>

<div class="container">
    <div class="row" id="head">
        <div class="col">
            <div id="countdown" class="countdown"></div>
        </div>
        <div class="progress">
            <div class="progress-bar progress-bar-striped progress-bar-animated" id="pro-bar" role="progressbar" aria-valuemin="0" aria-valuemax="100"></div>
        </div>
    </div>

    <div class="row" id="middle">
        <div id="questionLin" class="col">
        </div>
        <div class="section">
            <div id="my-qr-reader"></div>
        </div>
    </div>
    
</div>



@section Scripts
{
    @if (Model.ModeString == "phygital")
    {
        <script src="@Url.Content("~/js/linflowPhygital.js")" defer></script>
        <script src="https://unpkg.com/html5-qrcode"></script>
        <script src="@Url.Content("~/js/qrScanner.js")" defer></script>
        <script src="@Url.Content("~/js/timer.js")" defer></script>
    }
    else
    {
        <script src="@Url.Content("~/js/linflow.js")" defer></script>
        <script src="@Url.Content("~/js/timer.js")" defer></script>
                   
    }
}

IpProject/UI_MVC/Views/LineFlow/ThankPage.cshtml
@model dynamic

@{
    ViewBag.Title = "Bedankt";
    Layout = "_Layout";
}

<div class="container">
    <div class="row" id="head">
        <div class="col">
            <h1>Bedankt</h1>
        </div>
    </div>

    <div class="row" id="middle">
        <div class="col-md-6 col-sm-12" id="infostart">
            Bij Netropolix streven we naar groei en verbetering, en jouw input is van onschatbare waarde voor ons.
            Door deel te nemen aan onze enquêtes en vragenlijsten,
            help je ons om onze producten en diensten nog beter af te stemmen op wat jij nodig hebt en wilt.<br/>
            <button id="startbutton" onclick="">Let's keep in touch</button>
        </div>
    </div>

    <div class="row" id="foot">
        <div class="col">
            <img src="~/img/logo.PNG" alt="logo" id="logo"/>
        </div>
    </div>

</div>